No subject


Sun May 13 13:41:23 UTC 2007


> PLEASE help me figure out ways to make it better.

For ease of administration debian also starts a (initially generated but 
customizable and preserved during update) background script for table 
checks etc. For debian this should be included, because it is existing 
and desireable functionality. This would be a good option to add.

I have made a version of Monty's script that includes all the above, 
without being Debian specific (see attachments). This version should 
seamlessly replace debian's version (/etc/init.d/mysql, 
/usr/share/mysql/debian-start.inc.sh
and the generated /etc/mysql/debian-start). I tested this with the 
mysqlmachine-etch64 machine.

The mysqlmaintenance.sh is made to contain the check/upgrade 
functionality as a separate script to keep the mysql.server.sh script 
clean and only for 'start|stop|status". It made for easy use in any 
custom startup script.

A simple diff should show all differences with Monty's mysql.server.sh 
script. Any distro should be able to use the adjusted version without 
any extra startup setting.

To add a /etc/mysql/debian-start like default script for other distro's 
than debian, you can either adapt the mysqlmaintenance.sh script to 
include the defaults or add two settings to the my.cnf:

   # Custom Maintenance Script settings that runs at startup (debian 
example):
   extra-startup-script=/etc/mysql/debian-start
   extra_defaults=/etc/mysql/debian.cnf


> (especially as currently it outputs extra linefeeds and dots that I
> don't want it to on debian, I think)

The output (when there are no faults) look good to me, no extra line 
feeds or dots the debian version
of the start script does not have. Are there specific cases where the 
printing goes wrong?

With regards,
Paul

--------------040007090508090509030706
Content-Type: text/plain;
 name="adjusted-mysql.server.sh"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
 filename="adjusted-mysql.server.sh"

#!/bin/sh
# Copyright Abandoned 1996 TCX DataKonsult AB & Monty Program KB & Detron HB
# This file is public domain and comes with NO WARRANTY of any kind

# MySQL daemon start/stop script.

# Usually this is put in /etc/init.d (at least on machines SYSV R4 based
# systems) and linked to /etc/rc3.d/S99mysql and /etc/rc0.d/K01mysql.
# When this is done the mysql server will be started when the machine is
# started and shut down when the systems goes down.

# Comments to support chkconfig on RedHat Linux
# chkconfig: 2345 64 36
# description: A very fast and reliable SQL database engine.

# Comments to support LSB init script conventions
### BEGIN INIT INFO
# Provides: mysql
# Required-Start: $local_fs $network $remote_fs
# Should-Start: ypbind nscd ldap ntpd xntpd
# Required-Stop: $local_fs $network $remote_fs
# Default-Start:  2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: start and stop MySQL
# Description: MySQL is a very fast and reliable SQL database engine.
### END INIT INFO
 
# If you install MySQL on some other places than @prefix@, then you
# have to do one of the following things for this script to work:
#
# - Run this script from within the MySQL installation directory
# - Create a /etc/my.cnf file with the following information:
#   [mysqld]
#   basedir=<path-to-mysql-installation-directory>
# - Add the above to any other configuration file (for example ~/.my.ini)
#   and copy my_print_defaults to /usr/bin
# - Add the path to the mysql-installation-directory to the basedir variable
#   below.
#
# If you want to affect other MySQL variables, you should make your changes
# in the /etc/my.cnf, ~/.my.cnf or other MySQL configuration files.

# If you change base dir, you must also change datadir. These may get
# overwritten by settings in the MySQL configuration files.

basedir=
datadir=

# Default value, in seconds, afterwhich the script should timeout waiting
# for server start. 
# Value here is overriden by value in my.cnf. 
# 0 means don't wait at all
# Negative numbers mean to wait indefinitely
service_startup_timeout=-1

# The following variables are only set for letting mysql.server find things.

# Set some defaults
pid_file=
server_pid_file=
use_mysqld_safe=1
user=@MYSQLD_USER@
if test -z "$basedir"
then
  basedir=@prefix@
  bindir=@bindir@
  if test -z "$datadir"
  then
    datadir=@localstatedir@
  fi
  sbindir=@sbindir@
  libexecdir=@libexecdir@
else
  bindir="$basedir/bin"
  if test -z "$datadir"
  then
    datadir="$basedir/data"
  fi
  sbindir="$basedir/sbin"
  libexecdir="$basedir/libexec"
fi

# datadir_set is used to determine if datadir was set (and so should be
# *not* set inside of the --basedir= handler.)
datadir_set=

#
# Use LSB init script functions for printing messages, if possible
#
lsb_functions="/lib/lsb/init-functions"
if test -f $lsb_functions ; then
  . $lsb_functions
else
  log_success_msg()
  {
    echo " SUCCESS! $@"
  }
  log_failure_msg()
  {
    echo " ERROR! $@"
  }
  log_warning_msg()
  {
    echo " WARNING! $@"
  }
fi

PATH=/sbin:/usr/sbin:/bin:/usr/bin:$basedir/bin
export PATH

mode=$1    # start or stop
shift
other_args="$*"   # uncommon, but needed when called from an RPM upgrade action
           # Expected: "--skip-networking --skip-grant-tables"
           # They are not checked here, intentionally, as it is the resposibility
           # of the "spec" file author to give correct arguments only.

case `echo "testing\c"`,`echo -n testing` in
    *c*,-n*) echo_n=   echo_c=     ;;
    *c*,*)   echo_n=-n echo_c=     ;;
    *)       echo_n=   echo_c='\c' ;;
esac

is_defined()
{
  declare -F | grep -q $1
  return $?
}
# These are LSB extensions used by Debian, but we want to play nice everywhere
if ! is_defined log_progress_msg ; then 
  log_progress_msg()
  {
    echo $echo_n "$1$echo_c"
  }
fi 
if ! is_defined log_end_msg ; then 
  log_end_msg()
  {
    # Don't actually want to do anything if the system doesn't have this
    end_msg=$1
  }
fi 
if ! is_defined log_daemon_msg ; then 
  log_daemon_msg()
  {
    echo $echo_n "$1"
  }
fi

parse_server_arguments() {
  for arg do
    case "$arg" in
      --basedir=*)  basedir=`echo "$arg" | sed -e 's/^[^=]*=//'`
                    bindir="$basedir/bin"
		    if test -z "$datadir_set"; then
		      datadir="$basedir/data"
		    fi
		    sbindir="$basedir/sbin"
		    libexecdir="$basedir/libexec"
        ;;
      --datadir=*)  datadir=`echo "$arg" | sed -e 's/^[^=]*=//'`
		    datadir_set=1
	;;
      --user=*)  user=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
      --pid-file=*) server_pid_file=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
      --service-startup-timeout=*) service_startup_timeout=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
      --extra-startup-script=*) extra_startup_script=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
      --extra-defaults=*) extra_defaults=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
      --use-mysqld_safe) use_mysqld_safe=1;;
      --use-manager)     use_mysqld_safe=0;;
    esac
  done
}

parse_manager_arguments() {
  for arg do
    case "$arg" in
      --pid-file=*) pid_file=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
      --user=*)  user=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
    esac
  done
}

wait_for_pid () {
  i=0
  while test $i -ne $service_startup_timeout; do
    sleep 1
    case "$1" in
      'created')
        test -s $pid_file && i='' && break
        kill -0 $2 || break # if the program goes away, stop waiting
        ;;
      'removed')
        test ! -s $pid_file && i='' && break
        ;;
      *)
        log_failure_msg "wait_for_pid () usage: wait_for_pid created|removed"
        ;;
    esac
    log_progress_msg "."
    i=`expr $i + 1`
  done

  if test -z "$i" ; then
    return 0
  else
    log_failure_msg
    return 1
  fi
}


MAINTENACE_CMD=/usr/share/mysql/mysqlmaintenance.sh

# Just call and enjoy the benefits.
# Call after wait for PID.
do_maintenance() {
    extrastartupscript=`$MAINTENACE_CMD --get-custom-startup-script`
    if test -z "$extrastartupscript"; then
        # use setting from my.cnf if there is no standard file.
        extrastartupscript=$extra_startup_script
    fi
    if test -z "$extrastartupscript"; then
        # nothing todo
        return 0
    fi
    if ! test -x "$extrastartupscript"; then
        echo $extrastartupscript is missing or not executable.
        return 1
    fi

    # This adds support for a generated default settings cnf,
    # like with Debian or for automaticly changing passwords for
    # use with:
    # mysqladmin --defaults-file=...
    defaultsfile=`$MAINTENACE_CMD --get-defaults`
    if test -z "$defaultsfile"; then
        # use setting from my.cnf if there is no standard file.
        defaultsfile=$extra_defaults
    fi
    if test -z "$defaultsfile"; then
        log_failure_msg "Missing extra_defaults=... in my.cnf"
        return 1
    fi
    if ! test -f "$defaultsfile"; then
        log_failure_msg "$defaultsfile missing (for $extrastartupscript)"
        return 1
    fi

    # Print any std -/error output from the extra_startup_script 
    # with lsb functions.
    tmpfile="`tempfile -s tempfile -p sqld. -s .extra_startup.errors`"
    output="`$extrastartupscript $defaultsfile 2> $tmpfile`"
    scriptresult=$?
    if ! test -z "$output"; then
        log_action_msg "$output"
    fi
    if test $scriptresult -ne 0; then
        log_failure_msg "`cat $tmpfile`"
    fi
    rm -f $tmpfile
    return $scriptresult
}


# Get arguments from the my.cnf file,
# the only group, which is read from now on is [mysqld]
if test -x ./bin/my_print_defaults
then
  print_defaults="./bin/my_print_defaults"
elif test -x $bindir/my_print_defaults
then
  print_defaults="$bindir/my_print_defaults"
elif test -x $bindir/mysql_print_defaults
then
  print_defaults="$bindir/mysql_print_defaults"
else
  # Try to find basedir in /etc/my.cnf
  conf=/etc/my.cnf
  print_defaults=
  if test -r $conf
  then
    subpat='^[^=]*basedir[^=]*=\(.*\)$'
    dirs=`sed -e "/$subpat/!d" -e 's//\1/' $conf`
    for d in $dirs
    do
      d=`echo $d | sed -e 's/[ 	]//g'`
      if test -x "$d/bin/my_print_defaults"
      then
        print_defaults="$d/bin/my_print_defaults"
        break
      fi
      if test -x "$d/bin/mysql_print_defaults"
      then
        print_defaults="$d/bin/mysql_print_defaults"
        break
      fi
    done
  fi

  # Hope it's in the PATH ... but I doubt it
  test -z "$print_defaults" && print_defaults="my_print_defaults"
fi

#
# Read defaults file from 'basedir'.   If there is no defaults file there
# check if it's in the old (depricated) place (datadir) and read it from there
#

extra_args=""
if test -r "$basedir/my.cnf"
then
  extra_args="-e $basedir/my.cnf"
else
  if test -r "$datadir/my.cnf"
  then
    extra_args="-e $datadir/my.cnf"
  fi
fi

parse_server_arguments `$print_defaults $extra_args mysqld server mysql_server mysql.server`

# Look for the pidfile 
parse_manager_arguments `$print_defaults $extra_args manager`

#
# Set pid file if not given
#
if test -z "$pid_file"
then
  pid_file=$datadir/mysqlmanager-`hostname`.pid
else
  case "$pid_file" in
    /* ) ;;
    * )  pid_file="$datadir/$pid_file" ;;
  esac
fi
if test -z "$server_pid_file"
then
  server_pid_file=$datadir/`hostname`.pid
else
  case "$server_pid_file" in
    /* ) ;;
    * )  server_pid_file="$datadir/$server_pid_file" ;;
  esac
fi

# Safeguard (relative paths, core dumps..)
cd $basedir

case "$mode" in
  'start')
    # Start daemon

    manager=$bindir/mysqlmanager
    if test -x $libexecdir/mysqlmanager
    then
      manager=$libexecdir/mysqlmanager
    elif test -x $sbindir/mysqlmanager
    then
      manager=$sbindir/mysqlmanager
    fi

    log_daemon_msg "Starting MySQL" "mysqld"
    if test -x $manager -a "$use_mysqld_safe" = "0"
    then
      if test -n "$other_args"
      then
        log_end_msg 1
        log_failure_msg "MySQL manager does not support options '$other_args'"
        exit 2
      fi
      # Give extra arguments to mysqld with the my.cnf file. This script may
      # be overwritten at next upgrade.
	  $manager --user=$user --pid-file=$pid_file >/dev/null 2>&1 &
	  wait_for_pid created $!; return_value=$?

      # Make lock for RedHat / SuSE
      if test -w /var/lock/subsys
      then
        touch /var/lock/subsys/mysqlmanager
      fi
      log_end_msg $return_value

	  if test $return_value -q 0; then
		  do_maintenance
	  fi

    elif test -x $bindir/mysqld_safe
    then
      # Give extra arguments to mysqld with the my.cnf file. This script
      # may be overwritten at next upgrade.
      pid_file=$server_pid_file
	  $bindir/mysqld_safe --datadir=$datadir --pid-file=$server_pid_file $other_args >/dev/null 2>&1 &
	  wait_for_pid created $!; return_value=$?

      # Make lock for RedHat / SuSE
      if test -w /var/lock/subsys
      then
        touch /var/lock/subsys/mysql
      fi
      log_end_msg $return_value

	  if test $return_value -eq 0; then
	  	do_maintenance
	  fi

    else
      log_end_msg 1
      log_failure_msg "Couldn't find MySQL manager or server"
      exit 1
    fi
    ;;

  'stop')
    # Stop daemon. We use a signal here to avoid having to know the
    # root password.

    # The RedHat / SuSE lock directory to remove
    lock_dir=/var/lock/subsys/mysqlmanager

    log_daemon_msg "Shutting down MySQL" "mysqld"

    # If the manager pid_file doesn't exist, try the server's
    if test ! -s "$pid_file"
    then
      pid_file=$server_pid_file
      lock_dir=/var/lock/subsys/mysql
    fi

    if test -s "$pid_file"
    then

      read mysqlmanager_pid < $pid_file 
      kill $mysqlmanager_pid
      # mysqlmanager should remove the pid_file when it exits, so wait for it.
      wait_for_pid removed; return_value=$?

      # delete lock for RedHat / SuSE
      if test -f $lock_dir
      then
        rm -f $lock_dir
      fi
      log_end_msg $return_value
      exit $return_value
    fi
    # Stopping a server that isn't running is considered a success
    # But we can warn about it anyway
    log_end_msg 0
    log_warning_msg "MySQL manager or server PID file could not be found!"
    ;;

  'restart')
    # Stop the service and regardless of whether it was
    # running or not, start it again.
    if $0 stop $other_args; then
      $0 start $other_args
    else
      log_failure_msg "Failed to stop running server, so refusing to try to start."
      exit 1
    fi
    ;;

  'reload'|'force-reload')
    if test -s "$server_pid_file" ; then
      log_daemon_msg "Reloading MySQL" 
      read mysqld_pid <  $server_pid_file
      if kill -HUP $mysqld_pid ; then 
        log_end_msg 0
      else 
        log_end_msg 1
        exit 1
      fi
      touch $server_pid_file
    else
      log_end_msg 1
      log_failure_msg "MySQL PID file could not be found!"
      exit 1
    fi
    ;;
    
  'status')
    # First, check to see if pid file exists
    if test -s "$server_pid_file" ; then 
      read mysqld_pid < $server_pid_file
      if kill -0 $mysqld_pid 2>/dev/null ; then 
        log_success_msg "MySQL running ($mysqld_pid)"
      else
		log_end_msg 1
        log_failure_msg "MySQL is not running, but PID file exists"
        exit 1
      fi
    else
      # Try to find appropriate mysqld process
      mysqld_pid=`pidof $sbindir/mysqld`
      if test -z $mysqld_pid ; then 
        if test "$use_mysqld_safe" = "0" ; then 
          lockfile=/var/lock/subsys/mysqlmanager
        else
          lockfile=/var/lock/subsys/mysql
        fi 
        if test -f $lockfile ; then 
	  	  log_end_msg 1
          log_failure_msg "MySQL is not running, but lock exists"
          exit 2
        fi 
        log_end_msg 1
        log_failure_msg "MySQL is not running"
        exit 3
      else
	log_end_msg 1
        log_failure_msg "MySQL is running but PID file could not be found"
        exit 4
      fi
    fi
    ;;
    *)
      # usage
      echo "Usage: $0  {start|stop|restart|reload|force-reload|status}  [ MySQL server options ]"
      exit 1
    ;;
esac

exit 0

--------------040007090508090509030706
Content-Type: text/plain;
 name="debian-start"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
 filename="debian-start"

#!/bin/bash
#
# This script is executed by "/etc/init.d/mysql" on every (re)start.
# 
# Changes to this file will be preserved when updating the Debian package.
#

## Set the default config file setting.
DEFAULT_CNF=$1

MAINTENACE_CMD="/usr/share/mysql/mysqlmaintenance.sh"

# The following commands should be run when the server is up but in background
# where they do not block the server start and in one shell instance so that
# they run sequentially. They are supposed not to echo anything to stdout.
# If you want to disable the check for crashed tables comment
# "check_for_crashed_tables" out.  
# (There may be no output to stdout inside the background process!)
echo "Checking for corrupt, not cleanly closed and upgrade needing tables."
(
	$MAINTENACE_CMD upgrade_system_tables_if_necessary $DEFAULT_CNF;
	$MAINTENACE_CMD check_for_crashed_tables $DEFAULT_CNF;
) >&2 &

exit 0

--------------040007090508090509030706
Content-Type: text/plain;
 name="mysqlmaintenance.sh"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
 filename="mysqlmaintenance.sh"

#!/bin/bash
#
# Script for upgrading and checking tables.
#
# Other usefull mysql maintenance script can also be added.
#

CHECKTABLE_CMD=check_for_crashed_tables
TRYUPGRADE_CMD=upgrade_system_tables_if_necessary
GET_DEFAULTS=--get-defaults
GET_EXTRA_STARTUP_SCRIPT=--get-custom-startup-script

USAGE="usage: $0
<$CHECKTABLE_CMD|$TRYUPGRADE_CMD|$GET_DEFAULTS|$GET_EXTRA_STARTUP_SCRIPT> [DEFAULT CNF FILE] "

CMD=$1
DEFAULTS_FILE=$2

DEFAULT_STARTUP_SCRIPT=

# Here distribution defaults are defined

if [ -f "/etc/debian_version" ]; then
    # Ensure everything keeps working for debian/ubuntu
    # with missing --mysqladmin-defaults setting
    # in the my.cnf. We know where it is anyway.
    DEFAULTS_FILE=/etc/mysql/debian.cnf
	DEFAULT_STARTUP_SCRIPT="/etc/mysql/debian-start"
fi

# You can add defaults for the other distributions
# here, making any --mysqladmin-defaults setting
# in my.cnf obsolete if all are listed.

# Commands for getting distibution related info:

if [ "$CMD" = "$GET_DEFAULTS" ]; then
	if test -n "$DEFAULTS_FILE"; then
		echo $DEFAULTS_FILE
	fi
	exit 0
fi

if [ "$CMD" = "$GET_EXTRA_STARTUP_SCRIPT" ]; then
	if test -n "$DEFAULT_STARTUP_SCRIPT"; then
        echo $DEFAULT_STARTUP_SCRIPT
    fi
	exit 0	
fi

# checks for running the functions in this script.

if [ -z "$DEFAULTS_FILE" ]; then
	echo "Defaults config file expected, with this distribution"
	echo "the <DEFAULT CNF FILE> parameter is required."
    echo $USAGE 
    exit 1
fi

if [ ! -f "$DEFAULTS_FILE" ]; then
    echo "Default config file missing: $DEFAULT_FILE"
    exit 1
fi

# Check that the chosen commands are listed.
if [ "$CMD" != "$CHECKTABLE_CMD" -a "$CMD" != "$TRYUPGRADE_CMD" ]; then
		if [ -n "$CMD" ]; then
			echo "Invalid command: $CMD"
		fi
        echo $USAGE 
        exit 1
fi

if [ ! -f "$DEFAULTS_FILE" ]; then
        echo "Default config file expected: $DEFAULTS_FILE"
        exit 1
fi

# Some shortcuts:
MYADMIN="/usr/bin/mysqladmin --defaults-file=$DEFAULTS_FILE"
MYUPGRADE="/usr/bin/mysql_upgrade --defaults-extra-file=$DEFAULTS_FILE"
MYCHECK="/usr/bin/mysqlcheck --defaults-file=$DEFAULTS_FILE"
MYCHECK_SUBJECT="WARNING: mysqlcheck has found corrupt tables"
MYCHECK_PARAMS="--all-databases --fast --silent"
MYCHECK_RCPT="root"

## Check all unclosed tables.
# - Requires the server to be up.
# - Is supposed to run silently in background. 
function check_for_crashed_tables() {
  set -e
  set -u

  # But do it in the background to not stall the boot process.
  logger -p daemon.info -i -t$0 "Checking for crashed MySQL tables."

  # Checking for $? is unreliable so the size of the output is checked.
  # Some table handlers like HEAP do not support CHECK TABLE.
  tempfile=`tempfile`
  LC_ALL=C $MYCHECK $MYCHECK_PARAMS \
    2>&1 \
    | perl -e '$_=join("", <>); s/^[^\n]+\n(error|note)\s+: The (handler|storage engine) for the table doesn.t support check\n//smg;print;' \
    > $tempfile
  if [ -s $tempfile ]; then
    (
      /bin/echo -e "\n" \
        "Improperly closed tables are also reported if clients are accessing\n" \
 	"the tables *now*. A list of current connections is below.\n";
       $MYADMIN processlist status
    ) >> $tempfile
    # Check for presence as a dependency on mailx would require an MTA.
    if [ -x /usr/bin/mailx ]; then mailx -e -s"$MYCHECK_SUBJECT" $MYCHECK_RCPT < $tempfile; fi
    (echo "$MYCHECK_SUBJECT"; cat $tempfile) | logger -p daemon.warn -i -t$0
  fi
  rm $tempfile
}

## Check for tables needing an upgrade.
# - Requires the server to be up.
# - Is supposed to run silently in background. 
function upgrade_system_tables_if_necessary() {
  set -e
  set -u

  logger -p daemon.info -i -t$0 "Upgrading MySQL tables if necessary."

  # Filter all "duplicate column", "duplicate key" and "unknown column"
  # errors as the script is designed to be idempotent.
  LC_ALL=C $MYUPGRADE \
    2>&1 \
    | egrep -v '^(1|@had|ERROR (1054|1060|1061))' \
    | logger -p daemon.warn -i -t$0
}


## hook to the command's execution.
$CMD

--------------040007090508090509030706--





More information about the pkg-mysql-maint mailing list